#pragma once
#include "comm.h"
using namespace std;
class Driver
{
public:
	Run_Mode mode;
	int threadnum;
	double dcutoff;

private:
	int K;//final mixture number
	int iC_Now;//mixture number of current time
	int D;// feature dimension
	vec vWeight; //weight vector 
	vec vMean;//mean vector 
	mat mM;//mean matrix
	vec mM0;//mean matrix
	cube mInvVar;//cube of var matrix
	cube mV; //Whishart: inv(W) = V'*V
	mat mW0;
	mat minvW0;
	vec vE_ln_pi;
	vec vE_V;
	vec vE_1_V;
	vec vE_ln_L;
	vec vgamma1;
	vec vgamma2;
	double E_alpha;
	double E_lnalpha;
	double vNu0;
	double vbeta0;
	double vbeta1;
	vec vNu;
	vec vNx; //1st order 
	mat mEx;
	cube mSx;
	vec vbeta;
	double lndetW0;
	vec lndetW;
	vec rnk0;
	double alpha_omega1;
	double alpha_omega2;
	double alpha_s1;
	double alpha_s2;
	int iEM_Iternum_Max;//Iternum max times
	double dWeightmin; // Weight Threshold
	int cluster_min;
	double dstatsmin; //statistics Threshold
	double dVar_floor;
	double Cluster_MIN;//cluster Threshold
	double EM_MIN;//EM Threshold
	double Lower_bound_All; // The amount of change
	double Dm;
	double Dm_Last;
	int n_Shed; // deleted mixture number
	double eps;// Iterative threshold
	bool bDoKmeans;
	bool bcos;
	string sProjectionDir;
	string sHp_Path;
	string sScore_Dir;
	string sFeatureList;
	string sClusterList;
	string sProjectionList;
	string sScoreList;
	string weight_str;
	string sLabelFile;
	string sPathWayFile;
	string sCluster_Result;
	vector <string> labelset;

public:
	Driver(void);
	~Driver(void);
	bool Init(int ac, char* av[]);
	bool Load();
	bool Save();
	bool Exit();
	bool Compute_Cluster();
	bool Compute_Project();
	bool PreTrain();
	bool Train();
	bool Compute_Score();
	bool ComputeConst();
private:
	bool Cluster_Vector(mat& oriMat, mat& probs);
	bool LoadLabel(string filelist, vector <string> &labelset);
	bool SaveScore(const string sScore_Result, const vector <string> &labelset, const mat &scoreVec, bool bsort);
	bool Score(mat &HMatrix, vec & weight_vec, vec &scoreVec);
	double Score_Cosine(vec &Hvector, vec &Hprob);
	bool Norm_01(vec &scoreVec);
	double Score_Euclidean(vec &Hvector, vec &Hprob);
	bool Project_Vector(mat &oriMat, mat &vvector, mat &probs);
	double Compute_rnk(vec & rnk, const vec & feat) const;
	double E_Step(vec * N, mat * F, cube * S, const mat &buf);
	bool M_Step(vec & N, mat & F, cube & S, mat &buf);
	int Shed_Mixture();
	double ComputeCost(vec &N, mat &F, cube &S, double q_z_at_v) const;
	bool InitVariables(mat &labelvectors);
	bool UpdateMPIVariables();
	double H(double ln_det_W, double v, int D) const;
	double Minus_ln_B(double ln_det_W, double v, int D) const;
	double E_ln_L(double ln_det_W, double v, int D) const;
	double log_det_inv(mat & orimat) const;
	double Mahalanobis_Distance(const vec & feat, const vec &mean, const mat &InvVar) const;
};

